unit NumWord;
interface
Uses
 Windows, Messages, SysUtils, Classes;

Type
  TLanguage=(English,Turkish);
Type
  TNumWord = Class(Tcomponent)
  Private
      Function DelSpaces(St: String; Ch: Char) : String;
      Function NumString(Number: Real; Width, Decimals: Byte) : String;
      Function RightSpaces(St: String; Width: Integer; Ch: Char) : String;
  Protected
      FLanguage:TLanguage;
      Procedure SetLanguage(Value:TLanguage);
  Public
      constructor Create( AOwner: TComponent ); override;
      destructor Destroy; override;
  Published
      Property Language:TLanguage Read FLanguage Write SetLanguage Default Turkish;
      Function Word(Value:Real;Des:Byte;MoneySign:String):String;
End;


Procedure Register;

implementation

Procedure Register;
Begin
  RegisterComponents('AhmSoft',[TNumWord]);
End;
Function TNumWord.NumString(Number: Real; Width, Decimals: Byte) : String;
Var
  St: String;
Begin
  Str(Number: Width: Decimals, St);
  Result := St;
End;
Function TNumWord.DelSpaces(St: String; Ch: Char) : String;
Var
  K: Integer;
Begin
  Result := '';
  For K := 1 TO Length(St) Do
  Begin
    If (St[K]<>Ch) And (St[K]<>#0) Then
    Begin
      Result := Result + St[K];
    End;
  End;
End;

Function TNumWord.RightSpaces(St: String; Width: Integer; Ch: Char) : String;
Var
  K: Integer;
Begin
  For K := 1 To Width - Length(St) Do
  Begin
    St := Ch + St;
  End;
  Result := St;
End;



Function TNumWord.Word(Value:Real;Des:Byte;MoneySign:String):String;

 // English
 
   Function WordEnglish(Value:Real;Des:Byte;MoneySign:String):String;
   Var
    NumStr:array[1..3,1..9] Of String[12];
      Srak:Array[1..5] Of String[3];
       Srk,Ds:String[20];
       Ps:Longint;
       R_Ok:Boolean;
       Hundred,Ten,One:Integer;
       ExitNumStr:String;
   Begin
     NumStr[1,1]:='ONE';    NumStr[2,1]:='TEN';      NumStr[3,1]:='ELEVEN';
     NumStr[1,2]:='TWO';    NumStr[2,2]:='TWENTY';   NumStr[3,2]:='TWELVE';
     NumStr[1,3]:='THREE';  NumStr[2,3]:='THIRTY';   NumStr[3,3]:='THIRTEEN';
     NumStr[1,4]:='FOUR';   NumStr[2,4]:='FOURTY';   NumStr[3,4]:='FOURTEEN';
     NumStr[1,5]:='FIVE';   NumStr[2,5]:='FIFTY';    NumStr[3,5]:='FIFTEEN';
     NumStr[1,6]:='SIX';    NumStr[2,6]:='SIXTY';    NumStr[3,6]:='SIXTEEN';
     NumStr[1,7]:='SEVEN';  NumStr[2,7]:='SEVENTY';  NumStr[3,7]:='SEVENTEEN';
     NumStr[1,8]:='EIGHT';  NumStr[2,8]:='EIGHTY';   NumStr[3,8]:='EIGHTEEN';
     NumStr[1,9]:='NINE';   NumStr[2,9]:='NINETY';   NumStr[3,9]:='NINETEEN';
     Srk:=DelSpaces(NumString(Value,15,Des),#32);
     Ps:=Pos('.',Srk);
     IF Ps > 0 Then
        Begin
         Ds:=Copy(Srk,Ps+1,5);Srk:=Copy(Srk,1,Ps-1);
        End
      Else
        Ds:='';

     Srk:=RightSpaces(Srk,12,'0');ExitNumStr:='';
     Srak[1]:=Copy(Srk,1,3); Srak[2]:=Copy(Srk,4,3);
     Srak[3]:=Copy(Srk,7,3); Srak[4]:=Copy(Srk,10,3);
     Ps:=1; R_Ok:=True;
     While R_Ok Do
       Begin
         Case Ps Of
              1:Srak[5]:=Srak[1];
              2:Srak[5]:=Srak[2];
              3:Srak[5]:=Srak[3];
              4:Srak[5]:=Srak[4];
         End;
         IF Srak[5] <> '000' Then
            Begin
              Hundred:=StrToInt(Copy(Srak[5],1,1));
                  Ten:=StrToInt(Copy(Srak[5],2,1));
                  One:=StrToInt(Copy(Srak[5],3,1));
              IF Hundred > 0  Then ExitNumStr:=ExitNumStr+NumStr[1,Hundred]+'HUNDRED';// NumStr[3,Hundred];
              IF (Ten = 1) And (One > 0) Then
                  ExitNumStr:=ExitNumStr+NumStr[3,One]
                Else
                 Begin
                   IF Ten > 0 Then ExitNumStr:=ExitNumStr+NumStr[2,Ten];
                   IF One > 0 Then ExitNumStr:=ExitNumStr+NumStr[1,One];
                 End;
              Case Ps Of
                   1:ExitNumStr:=ExitNumStr+'BILLION,';
                   2:ExitNumStr:=ExitNumStr+'MILLION,';
                   3:ExitNumStr:=ExitNumStr+'THOUSAND,';
               End;
          End;
        Ps:=Ps+1;
        IF Ps > 4 Then R_Ok:=False;
       End;
    IF Length(Ds) > 0 then ExitNumStr:=ExitNumStr+'.'+DS;
    IF Length(ExitNumStr) > 0 Then ExitNumStr:=ExitNumStr+' '+MoneySign;
    Result:=ExitNumStr;
   End;

// Turkish

   Function WordTurkce(Value:Real;MoneySign:String):String;
   Var
    NumStr:array[1..2,1..9] Of String[12];
      Srak:Array[1..6] Of String[3];
       Srk,Ds:String[20];
       Ps:Longint;
       R_Ok:Boolean;
       Hundred,Ten,One:Integer;
       ExitNumStr:String;
   Begin
     NumStr[1,1]:='BR';      NumStr[2,1]:='ON';
     NumStr[1,2]:='K';      NumStr[2,2]:='YRM';
     NumStr[1,3]:='';       NumStr[2,3]:='OTUZ';
     NumStr[1,4]:='DRT';     NumStr[2,4]:='KIRK';
     NumStr[1,5]:='BE';      NumStr[2,5]:='ELL';
     NumStr[1,6]:='ALTI';     NumStr[2,6]:='ALTMI';
     NumStr[1,7]:='YED';     NumStr[2,7]:='YETM';
     NumStr[1,8]:='SEKZ';    NumStr[2,8]:='SEKSEN';
     NumStr[1,9]:='DOKUZ';    NumStr[2,9]:='DOKSAN';
     Srk:=DelSpaces(NumString(Value,15,Des),#32);
     Ps:=Pos('.',Srk);
     IF Ps > 0 Then
        Begin
         Ds:=Copy(Srk,Ps+1,5);Srk:=Copy(Srk,1,Ps-1);
        End
      Else
        Ds:='';

     Srk:=RightSpaces(Srk,15,'0');ExitNumStr:='';
     Srak[1]:=Copy(Srk,1,3); Srak[2]:=Copy(Srk,4,3);
     Srak[3]:=Copy(Srk,7,3); Srak[4]:=Copy(Srk,10,3);
     Srak[5]:=Copy(Srk,13,3);
     Ps:=1; R_Ok:=True;

     While R_Ok Do
       Begin
         Case Ps Of
              1:Srak[6]:=Srak[1];
              2:Srak[6]:=Srak[2];
              3:Srak[6]:=Srak[3];
              4:Srak[6]:=Srak[4];
              5:Srak[6]:=Srak[5];

         End;
         IF Srak[6] <> '000' Then
            Begin
              Hundred:=StrToInt(Copy(Srak[6],1,1));
                  Ten:=StrToInt(Copy(Srak[6],2,1));
                  One:=StrToInt(Copy(Srak[6],3,1));
              Case Hundred Of
                    1:ExitNumStr:=ExitNumStr+'YZ';
                 2..9:ExitNumStr:=ExitNumStr+NumStr[1,Hundred]+'YZ';
              End;
              IF Ten > 0 Then ExitNumStr:=ExitNumStr+NumStr[2,Ten];
              Case One Of
                    1:Begin
                       Case Ps Of
                         1..3,5:ExitNumStr:=ExitNumStr+NumStr[1,One];
                              4:IF (Ps = 4) And ((Hundred+Ten) > 0) Then
                                   ExitNumStr:=ExitNumStr+NumStr[1,One];
                       End;
                      End; 
                 2..9:ExitNumStr:=ExitNumStr+NumStr[1,One];
              End;
              Case Ps Of
                   1:ExitNumStr:=ExitNumStr+'TRLYON,';
                   2:ExitNumStr:=ExitNumStr+'MLYAR,';
                   3:ExitNumStr:=ExitNumStr+'MLYON,';
                   4:ExitNumStr:=ExitNumStr+'BN,';
               End;
          End;
        Ps:=Ps+1;
        IF Ps > 5 Then R_Ok:=False;
       End;
    IF Length(ExitNumStr) > 0 Then ExitNumStr:=ExitNumStr+' '+MoneySign;
    Result:=ExitNumStr;
   End;
Begin
   Case FLanguage OF
       Turkish:Result:=WordTurkce(Value,MoneySign);
       English:Result:=WordEnglish(Value,Des,MoneySign);
   End;
End;
Procedure TNumWord.SetLanguage(Value:TLanguage);
Begin
   FLanguage:=Value;
End;
Constructor TNumWord.Create( AOwner: TComponent );
Begin
  inherited Create( AOwner );
  FLanguage:=Turkish;
End;

Destructor TNumWord.Destroy;
Begin
  inherited Destroy;
End;

end.
